﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace GPIO
{
    class Program
    {
        static void Main(string[] args)
        {
            ConsoleKeyInfo key;
            int config0 = 0, config1 = 0, setup0 = 0, setup1 = 0, TestNumber = 1;//, GPIORead = 0x0, GPIORead1 = 0, GPIORead2 = 0;

            Console.WriteLine("Press '0' to Configures the outputs, sets the outputs to be 0 or 1, and reads inputs.");
            Console.WriteLine("Press '1' Coufigures the outputs as inputs or outputs.");
            Console.WriteLine("Press '2' Sets the outputs to be 0 or 1.");
            Console.WriteLine("Press '3' Reads from the inputs.");
            Console.WriteLine("Press '4' Do standard testing");
            Console.WriteLine("Press 'q' to Exit");
            key = Console.ReadKey();
            Console.WriteLine();
            while (key.Key != ConsoleKey.Q)
            {
                if (key.Key == ConsoleKey.D0)
                {
                    config0 = getNumber("config0");
                    config1 = getNumber("config1");
                    setup0 = getNumber("setup0");
                    setup1 = getNumber("setup1");
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);
                }
                else if (key.Key == ConsoleKey.D1)
                {
                    config0 = getNumber("config0");
                    config1 = getNumber("config1");
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 1);
                }
                else if (key.Key == ConsoleKey.D2)
                {
                    setup0 = getNumber("setup0");
                    setup1 = getNumber("setup1");
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 2);
                }
                else if (key.Key == ConsoleKey.D3)
                {
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 3);
                }
                else if (key.Key == ConsoleKey.D4)
                {

                    config0 = 0xFF; // This sets GPIO port 0 7-0 as inputs
                    config1 = 0x00; // This sets GPIO port 1 7-0 as outputs
                    setup0 = 0x00;
                    setup1 = 0xAA; // This sets port 1 7-0 value to be 10101010
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);

                    config0 = 0xFF;
                    config1 = 0x00;
                    setup0 = 0x00;
                    setup1 = 0x55;
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);

                    config0 = 0x00; // This sets GPIO port 0 7-0 as outputs
                    config1 = 0xFF; // This sets GPIO port 1 7-0 as inputs
                    setup0 = 0xAA; // This sets port 0 7-0 value to be 10101010
                    setup1 = 0x00;
                    TestNumber = 3;
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);

                    config0 = 0x00;
                    config1 = 0xFF;
                    setup0 = 0x55;
                    setup1 = 0x00;
                    TestNumber = 4;
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);

                    config0 = 0x00;
                    config1 = 0xFF;
                    setup0 = 0xFF;
                    setup1 = 0x00;
                    TestNumber = 5;
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);

                    config0 = 0x00;
                    config1 = 0xFF;
                    setup0 = 0x00;
                    setup1 = 0x00;
                    TestNumber = 6;
                    DoGPIO(config0, config1, setup0, setup1, TestNumber++, 0);
                }
                else
                {
                    Console.WriteLine("Press '0' to Configures the outputs, sets the outputs to be 0 or 1, and reads inputs.");
                    Console.WriteLine("Press '1' Coufigures the outputs as inputs or outputs.");
                    Console.WriteLine("Press '2' Sets the outputs to be 0 or 1.");
                    Console.WriteLine("Press '3' Reads from the inputs.");
                    Console.WriteLine("Press '4' Do standard testing");
                    Console.WriteLine("Press 'q' to Exit");
                }
                key = Console.ReadKey();
                Console.WriteLine();
            }
        }

        static int getNumber(string Descritption)
        {
            string inputText;
            int number = 0;
            bool parsed = false;
            Console.Write("Input " + Descritption + " as int: ");
            inputText = Console.ReadLine();
            parsed = false;
            while (!parsed)
            {
                parsed = Int32.TryParse(inputText, out number);
                if (!parsed)
                {
                    Console.Write("Input " + Descritption + " as int: ");
                    inputText = Console.ReadLine();
                }
            }
            return number;
        }


        // CommandSelection with do the following for the following values
        // 0 - Configures the outputs, sets the outputs to be 0 or 1, and reads inputs.
        // 1 - Coufigures the outputs as inputs or outputs
        // 2 - Sets the outputs to be 0 or 1
        // 3 - Reads from the inputs

        static void DoGPIO(int config0, int config1, int setup0, int setup1, int TestNumber, int CommandSelection)
        {
            int GPIORead = 0x0, GPIORead1 = 0, GPIORead2 = 0;
            String Commands = "";
            System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo();
            startInfo.FileName = "C:\\GPIO\\gpiodriver_diag.exe";
            startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            Console.WriteLine("GPIO Test " + TestNumber + " with CommandSelection = " + CommandSelection);
            Console.WriteLine("Config GPIO Port 0 to 0x{0:X}", config0);
            Console.WriteLine("Config GPIO Port 1 to 0x{0:X}", config1);
            Console.WriteLine("Setup GPIO Port 0 to 0x{0:X}", setup0);
            Console.WriteLine("Setup GPIO Port 1 to 0x{0:X}", setup1);
            Commands = config0 + " " + config1 + " " + setup0 + " " + setup1 + " " + CommandSelection;
            startInfo.Arguments = Commands;
            Process P = new Process();
            P.StartInfo = startInfo;
            P.Start();
            P.WaitForExit();
            GPIORead = P.ExitCode;

            GPIORead1 = GPIORead & 0xFF00;
            GPIORead1 = GPIORead1 >> 8;
            GPIORead2 = GPIORead & 0x00FF;
            Console.WriteLine("Returned Value GPIO port 1: " + GPIORead1.ToString("X"));
            Console.WriteLine("Returned Value GPIO port 2: " + GPIORead2.ToString("X"));
        }
    }

}
